program main
    implicit none
    integer, dimension(8) :: array = [5,3,4,2,6,1,7,0]
    
    write(*,*) array 
    call quicksort(array)
    write(*,*) array
    
contains 
    recursive subroutine quicksort(array)
        integer, dimension(:), intent(inout) :: array
        integer :: i,j,pivot, tmp
        i = 1
        j = size(array)
        pivot = array((size(array)+1)/2)
        do ! "Mikroschritt"
            do while (array(i)<pivot)
                i = i+1
            end do 
            do while (array(j)>pivot)
                j = j-1
            end do

            if (i > j) exit

            tmp = array(i)
            array(i) = array(j)
            array(j) = tmp 
            i = i+1
            j = j-1
        end do 
        if ( j>1 ) call quicksort(array(:j))
        if ( i<size(array) ) call quicksort(array(i:))
    end subroutine quicksort
end program main